// ConvDlg.cpp : t@C
//

#include "stdafx.h"
#include "MMA_G.h"
#include "GlobalData.h"
#include "ConvDlg.h"
#include "General.h"
#include "Complement.h"
#include "shlwapi.h"

// CConvDlg _CAO

IMPLEMENT_DYNAMIC(CConvDlg, CDialog)

CConvDlg::CConvDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvDlg::IDD, pParent)
	, m_MaiPath(_T(""))
	, m_pDoc(NULL)
	, m_GoEnable(false)
{
}

CConvDlg::~CConvDlg()
{
}

void CConvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_MAI, m_Edit_ref);
	DDX_Control(pDX, IDC_EDIT_UNITID, m_Edit_UnitId);
	DDX_Control(pDX, IDC_EDIT_SENSORID, m_Edit_SensorId);
	DDX_Control(pDX, IDC_EDIT_SENSORID2, m_Edit_SampleRate);
	DDX_Control(pDX, IDC_EDIT_START, m_Edit_StartTime);
	DDX_Control(pDX, IDC_EDIT_END, m_Edit_EndTime);
	DDX_Control(pDX, IDC_BUTTON_CONV, m_Button_Go);
	DDX_Control(pDX, IDCANCEL, m_Button_Cancel);
	DDX_Control(pDX, IDC_BUTTON_REF, m_Button_Ref);
	DDX_Control(pDX, IDC_COMBO_SENSOR, m_Combo_Sensor);
	DDX_Control(pDX, IDC_EDIT_QUALITY, m_Edit_Quality);
	DDX_Control(pDX, IDC_EDIT_ISS, m_Edit_Config);
	DDX_Control(pDX, IDC_EDIT_ISS2, m_Edit_Config2);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_Edit_Comment);
	DDX_Control(pDX, IDC_EDIT_DOWNLINK, m_Downlink);
	DDX_Control(pDX, IDC_COMBO_CATEGORY, m_Combo_Category);
	DDX_Control(pDX, IDC_COMBO_MEASUREMENT_KIND, m_Combo_MeasurementKind);
	DDX_Control(pDX, IDC_MEAS_TIME, m_Edit_MeasTime);
}


BEGIN_MESSAGE_MAP(CConvDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_CONV, &CConvDlg::OnBnClickedButtonConv)
	ON_BN_CLICKED(IDC_BUTTON_REF, &CConvDlg::OnBnClickedButtonRef)
	ON_BN_CLICKED(IDCANCEL, &CConvDlg::OnBnClickedCancel)
	ON_EN_UPDATE(IDC_EDIT_DOWNLINK, &CConvDlg::OnEnUpdateEditDownlink)
	ON_EN_UPDATE(IDC_EDIT_QUALITY, &CConvDlg::OnEnUpdateEditQuality)
	ON_EN_UPDATE(IDC_EDIT_ISS, &CConvDlg::OnEnUpdateEditIss)
	ON_EN_UPDATE(IDC_EDIT_S_YY, &CConvDlg::OnEnUpdateEditSYy)
	ON_EN_UPDATE(IDC_EDIT_S_MM, &CConvDlg::OnEnUpdateEditSMm)
	ON_EN_UPDATE(IDC_EDIT_S_DD, &CConvDlg::OnEnUpdateEditSDd)
	ON_EN_UPDATE(IDC_EDIT_S_H, &CConvDlg::OnEnUpdateEditSH)
	ON_EN_UPDATE(IDC_EDIT_S_M, &CConvDlg::OnEnUpdateEditSM)
	ON_EN_UPDATE(IDC_EDIT_S_S, &CConvDlg::OnEnUpdateEditSS)
	ON_EN_UPDATE(IDC_EDIT_E_YY, &CConvDlg::OnEnUpdateEditEYy)
	ON_EN_UPDATE(IDC_EDIT_E_MM, &CConvDlg::OnEnUpdateEditEMm)
	ON_EN_UPDATE(IDC_EDIT_E_DD, &CConvDlg::OnEnUpdateEditEDd)
	ON_EN_UPDATE(IDC_EDIT_E_H, &CConvDlg::OnEnUpdateEditEH)
	ON_EN_UPDATE(IDC_EDIT_E_M, &CConvDlg::OnEnUpdateEditEM)
	ON_EN_UPDATE(IDC_EDIT_E_S, &CConvDlg::OnEnUpdateEditES)
	ON_CBN_SELCHANGE(IDC_COMBO_SENSOR, &CConvDlg::OnCbnSelchangeComboSensor)
	ON_CBN_EDITCHANGE(IDC_COMBO_SENSOR, &CConvDlg::OnCbnEditchangeComboSensor)
	ON_EN_UPDATE(IDC_EDIT_ISS2, &CConvDlg::OnEnUpdateEditIss2)
	ON_CBN_SELCHANGE(IDC_COMBO_CATEGORY, &CConvDlg::OnCbnSelchangeComboCategory)
	ON_CBN_EDITCHANGE(IDC_COMBO_CATEGORY, &CConvDlg::OnCbnEditchangeComboCategory)
	ON_CBN_SELCHANGE(IDC_COMBO_MEASUREMENT_KIND, &CConvDlg::OnCbnSelchangeComboMeasurementKind)
	ON_CBN_EDITCHANGE(IDC_COMBO_MEASUREMENT_KIND, &CConvDlg::OnCbnEditchangeComboMeasurementKind)
END_MESSAGE_MAP()

// c[`bv\f[^
static const SToolTipData s_aToolTip[] = {
	{IDC_BUTTON_REF, "_ENf[^݂̑tH_I邽߂̃_CAOJ܂B"},
	{IDC_BUTTON_CONV, "ݒ肳ꂽeŁAHwlϊs܂B"},
	{IDCANCEL, "̃_CAO܂B"},
	{0, NULL}
};

// CConvDlg bZ[W nh

// _CAO֐
BOOL CConvDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	int	i;

	for (i = 0; g_pSensorInfo[i].idx != -1; i++) {
		m_Combo_Sensor.InsertString(g_pSensorInfo[i].idx, g_pSensorInfo[i].sel_dat);
	}

	// ͎s{^GRAY
	m_Button_Go.EnableWindow(m_GoEnable);

	// c[`bv\ݒ
	CGeneral::SetToolTip(m_tooltip, s_aToolTip, this);

	// JeSIݒ
	CGeneral::SetComboCategory(m_Combo_Category, "");

	// vޑIݒ
	CGeneral::SetComboMeasurementKind(m_Combo_MeasurementKind, "");

	return TRUE;
}

// GRAYɂ
void CConvDlg::KeyOff(void)
{
	m_Button_Go.EnableWindow(FALSE);
	m_Button_Cancel.EnableWindow(FALSE);
	m_Button_Ref.EnableWindow(FALSE);
}

// GRAY
void CConvDlg::KeyOn(void)
{
	m_Button_Go.EnableWindow(m_GoEnable);
	m_Button_Cancel.EnableWindow(TRUE);
	m_Button_Ref.EnableWindow(TRUE);
}

// Qƃ{^
void CConvDlg::OnBnClickedButtonRef()
{
    BROWSEINFO bInfo;
    LPITEMIDLIST pIDList;
	char	Buf[_MAX_PATH];
    
	strcpy_s(Buf, gDownlinkReferencePath);
    // BROWSEINFO\̂ɒlݒ
    bInfo.hwndOwner             = m_hWnd;		           // _CAO̐eEChẼnh
    bInfo.pidlRoot              = NULL;			           // [gtH_ITEMIDLIST̃|C^ (NULL̏ꍇfXNgbvtH_g܂j
    bInfo.pszDisplayName        = Buf;          // IꂽtH_󂯎obt@̃|C^
    bInfo.lpszTitle             = "_ENt@C݃tH_w";				   // c[r[̏㕔ɕ\镶 
    bInfo.ulFlags               = BIF_RETURNONLYFSDIRS;    // \tH_̎ނtO
    bInfo.lpfn                  = BrowseCallbackProc;      // BrowseCallbackProc֐̃|C^
    bInfo.lParam                = (LPARAM)Buf;             // R[obN֐ɓnl
    
    // tH_I_CAO\
    pIDList = ::SHBrowseForFolder(&bInfo);
    if(pIDList != NULL){
        // ItemIDListpXɕϊ܂
        if(!::SHGetPathFromIDList(pIDList, Buf)){
            // G[
        }

        // ŌpIDList̃|CgĂ郁܂
        ::CoTaskMemFree( pIDList );
		m_Edit_ref.SetWindowText(Buf);

		// mait@Cǂݍݏ
		Read();
    }
}

// tH_I_CAOR[obN֐
int CALLBACK CConvDlg::BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED)
		::SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData);

	return 0;
}

// mait@Cǂݍݏ
void CConvDlg::Read()
{
	CWaitCursor cursor;

	KeyOff();

	m_Edit_ref.GetWindowText(m_MaiPath);

	// wpXmait@Cǂ݁AJnIZbg
	if (m_maiFile.ReadMaiFile((LPCSTR)m_MaiPath, &m_startTime, &m_endTime) != 0) {
		// t@Ce\
		DspData();
	} else {
		m_Edit_ref.SetWindowText("");
	}

	KeyOn();
}

// t@Ce\
void CConvDlg::DspData(void)
{
	CString	str;

	// UnitId\
	str.Format("%d", m_maiFile.m_RsuId);
	m_Edit_UnitId.SetWindowText(str);

	// Sensor Id\
	str.Format("%d", m_maiFile.m_SensorId);
	m_Edit_SensorId.SetWindowText(str);

	// Tv[g\
	str.Format("%.2lf", m_maiFile.m_SampleRate);
	m_Edit_SampleRate.SetWindowText(str);

	// Jn\
	str.Format("%04d/%02d/%02d %02d:%02d:%02d"
		, m_startTime.m_YY, m_startTime.m_MM, m_startTime.m_DD
		, m_startTime.m_hh, m_startTime.m_mm, m_startTime.m_ss);
	m_Edit_StartTime.SetWindowText(str);

	// I\
	str.Format("%04d/%02d/%02d %02d:%02d:%02d"
		, m_endTime.m_YY, m_endTime.m_MM, m_endTime.m_DD
		, m_endTime.m_hh, m_endTime.m_mm, m_endTime.m_ss);
	m_Edit_EndTime.SetWindowText(str);

	// vԕ\
	COleDateTime a_oDateStart(m_startTime.m_YY, m_startTime.m_MM, m_startTime.m_DD
							, m_startTime.m_hh, m_startTime.m_mm, m_startTime.m_ss);
	COleDateTime a_oDateEnd(m_endTime.m_YY, m_endTime.m_MM, m_endTime.m_DD
							, m_endTime.m_hh, m_endTime.m_mm, m_endTime.m_ss);
	COleDateTimeSpan a_oMeasTime = a_oDateEnd - a_oDateStart;

	// 11NԂv𑱂Ă邱Ƃ͍lɂ̂ŁCł
	// őłCԂ̃f[^ȂƉ肷B
	// iN⌎̂Ƃ͍lȂj
	LONG a_lDays = a_oMeasTime.GetDays();
	LONG a_lHour = a_oMeasTime.GetHours();
	LONG a_lMin  = a_oMeasTime.GetMinutes();
	LONG a_lSec  = a_oMeasTime.GetSeconds();

	if(a_lDays > 0){
		a_lHour += a_lDays * 24;
	}

	str.Format("%dhours  %02dmin  %02dsec", a_lHour, a_lMin, a_lSec);
	m_Edit_MeasTime.SetWindowText(str);

}

// ϊs{^
void CConvDlg::OnBnClickedButtonConv()
{
	CWaitCursor cursor;

	// ̓f[^擾A`FbNAf[^ۑ
	if (GetInputData() != 0)
		return;

	// Event LogstH_݃`FbN
	if (!::PathFileExists(m_MaiPath + "\\Event Logs")) {
		if (AfxMessageBox("Event LogstH_܂Bϊp܂H", MB_YESNO | MB_ICONQUESTION) == IDNO) {
			AfxMessageBox("ϊ𒆎~܂B\nEvent LogstH_Rs[ĂēxsĂB", MB_OK | MB_ICONINFORMATION);
			return;
		}
	}

	if (AfxMessageBox("ϊs܂H", MB_YESNO) != IDYES)
		return;

	KeyOff();

	// ԏ
	Complement complement;
	if (complement.ComplementData(m_MaiPath, m_maiFile.m_maiFname)) {
		// Data Quality MeasureɃbZ[Wǉ
		m_maiFile.m_Idb.m_dataquality += ", Termperature Data Error was found and complemented.";

		// mait@Cēǂݍ
		m_maiFile.ReadMaiFile2(m_MaiPath + "\\" + m_maiFile.m_maiFname, TRUE);
	}

	// w莞̏o̓t@C
	m_maiFile.WriteData((LPCSTR)m_MaiPath, 0, m_endTime - m_startTime);

	m_pDoc->UpdateAllViews(NULL);

	AfxMessageBox("HwlϊI܂", MB_ICONINFORMATION | MB_OK);

	KeyOn();
}

// ͍ڂ擾
int CConvDlg::GetInputData(void)
{
	CString str, str2;

	UpdateData(TRUE);

	// _ENf[^w`FbN
	m_Edit_ref.GetWindowText(str);
	if (str.GetLength() == 0) {
		CGeneral::Alert("_ENf[^w肵ĂB");
		return 1;
	}

	// Sensor Coordinate System擾
	int	sidx;
	if ((sidx = m_Combo_Sensor.GetCurSel()) == -1) {
		CGeneral::Alert("Sensor Coordinate SystemFꂩIĂB");
		return 5;
	}

	// JeS擾
	m_Combo_Category.GetWindowText(str);
	str = str.Trim();
	if( str == _T("") ){
		CGeneral::Alert("JeSIĂB");
		return 11;
	}
	if (!CGeneral::CheckFileName("JeS", str))
		return 11;

	// vނ擾
	m_Combo_MeasurementKind.GetWindowText(str);
	str = str.Trim();
	if( str == _T("") ){
		CGeneral::Alert("vނIĂB");
		return 12;
	}
	if (!CGeneral::CheckFileName("v", str))
		return 12;

	// _EN擾
	m_Downlink.GetWindowText(str);
	str = str.Trim();
	// _EN󗓂̏ꍇ́CG[ƂB
	if( str == _T("") ){
		CGeneral::Alert("_EN󗓂łB_EN͂ĂB");
		return 6;
	}
/*
	// Quality Measure擾
	m_Edit_Quality.GetWindowText(str);
	str = str.Trim();
	// Data Quality Measure󗓂̏ꍇ́CG[ƂB
	if( str == _T("") ){
		CGeneral::Alert("Data Quality Measure󗓂łBData Quality Measure͂ĂB");
		return 7;
	}

	// ISS Config擾
	m_Edit_Config.GetWindowText(str);
	str = str.Trim();
	// ISS Configuration󗓂̏ꍇ́CG[ƂB
	if( str == _T("") ){
		CGeneral::Alert("ISS ConfigurationIncrement󗓂łBISS ConfigurationIncrement͂ĂB");
		return 8;
	}
	m_Edit_Config2.GetWindowText(str);
	str = str.Trim();
	// ISS Configuration󗓂̏ꍇ́CG[ƂB
	if( str == _T("") ){
		CGeneral::Alert("ISS ConfigurationFlight󗓂łBISS ConfigurationFlight͂ĂB");
		return 9;
	}
*/
	// Hwlf[^݃tH_쐬
	CString	pos, category, period, measurement_kind;
//	pos = SensorInfo[sidx].dat;
	pos = g_pSensorInfo[sidx].dat;
	m_Combo_Category.GetWindowText(category);
	m_Combo_MeasurementKind.GetWindowText(measurement_kind);
	period.Format("%04d%02d%02d%02d%02d%02d-%04d%02d%02d%02d%02d%02d"
		, m_startTime.m_YY
		, m_startTime.m_MM
		, m_startTime.m_DD
		, m_startTime.m_hh
		, m_startTime.m_mm
		, m_startTime.m_ss
		, m_endTime.m_YY
		, m_endTime.m_MM
		, m_endTime.m_DD
		, m_endTime.m_hh
		, m_endTime.m_mm
		, m_endTime.m_ss);
	if(m_maiFile.mkDir(pos, category, measurement_kind)){
		return 10;
	}

	// ̓f[^ۑ
	// NA
	m_maiFile.m_Idb.DelAll();
	// ZT[IDX
	m_maiFile.m_Idb.SetSensorIdx(sidx);
	// f[^͈
	m_maiFile.m_Idb.SetPeriod(period);
	// _EN
	m_Downlink.GetWindowText(str);
	m_maiFile.m_Idb.SetDownlink(str);
	// lbg[NIDiUNIT IDʂSj
	m_maiFile.m_Idb.SetNetworkid(m_maiFile.m_NetworkId);
	// jbgIDiUNIT IDʂSj
	m_maiFile.m_Idb.SetRsuId(m_maiFile.m_RsuId);
	// ZT[ID
	m_maiFile.m_Idb.SetSensorId(m_maiFile.m_SensorId);
	// ^C[
	str.Format("%04d%02d%02d%02d%02d%02d"
		, m_startTime.m_YY
		, m_startTime.m_MM
		, m_startTime.m_DD
		, m_startTime.m_hh
		, m_startTime.m_mm
		, m_startTime.m_ss);
	m_maiFile.m_Idb.SetTimeZero(str);
	// Tv[g
	m_maiFile.m_Idb.SetSampleRate(m_maiFile.m_SampleRate);
	// ۑpX
	m_maiFile.m_Idb.SetPath(m_maiFile.m_ConvDataPath);
	// Sensor Co Sys
	m_maiFile.m_Idb.SetSensorcosys(pos);
	// Data Co Sys
	m_maiFile.m_Idb.SetDatacosys(pos);
	// Data Quality
	m_Edit_Quality.GetWindowText(str);
	m_maiFile.m_Idb.SetDataquality(str);
	// ISS Config
	m_Edit_Config.GetWindowText(str);
	m_Edit_Config2.GetWindowText(str2);
	CString str3;
	if (!str.IsEmpty() || !str2.IsEmpty()) {
		str3 = "Increment: ";
		str3 += str;
		str3 += ", Flight: ";
		str3 += str2;
	} else
		str3.Empty();
	m_maiFile.m_Idb.SetIssconfig(str3);
	// Rg
	m_Edit_Comment.GetWindowText(str);
	m_maiFile.m_Idb.SetComment(str);
	// JeS
	m_Combo_Category.GetWindowText(str);
	m_maiFile.m_Idb.SetCategory(str);
	// v
	m_Combo_MeasurementKind.GetWindowText(str);
	m_maiFile.m_Idb.SetMeasurementKind(str);

	// X^[g^CYYYYiNjMM()DD()SSSSSSSSi~bj
	m_maiFile.m_Idb.SetStartTime(
		m_startTime.m_YY
		, m_startTime.m_MM
		, m_startTime.m_DD
		, (m_startTime.m_hh * 60 * 60 + m_startTime.m_mm * 60 + m_startTime.m_ss) * 1000);

	// ͊JnԂn
	m_maiFile.m_In_startTime = m_startTime;

	return 0;
}

bool CConvDlg::CheckData(void)
{
	CString str;

	UpdateData(TRUE);

	// _ENf[^w`FbN
	m_Edit_ref.GetWindowText(str);
	if (str.IsEmpty())
		return false;

	// Sensor Coordinate System擾
	if (m_Combo_Sensor.GetCurSel() == -1)
		return false;

	// JeS擾
	m_Combo_Category.GetWindowText(str);
	if (str.IsEmpty())
		return false;

	// vނ擾
	m_Combo_MeasurementKind.GetWindowText(str);
	if (str.IsEmpty())
		return false;

	// _EN擾
	m_Downlink.GetWindowText(str);
	if (str.IsEmpty())
		return false;
/*
	// Quality Measure擾
	m_Edit_Quality.GetWindowText(str);
	if (str.IsEmpty())
		return false;

	// ISS Config擾
	m_Edit_Config.GetWindowText(str);
	if (str.IsEmpty())
		return false;

	// ISS Config擾
	m_Edit_Config2.GetWindowText(str);
	if (str.IsEmpty())
		return false;
*/
	return true;
}

void CConvDlg::OnBnClickedCancel()
{
	// f[^Zbg
	m_maiFile.ResetData();

	OnCancel();
}

void CConvDlg::SetDocPtr(CDocument *pDoc)
{
	m_pDoc = pDoc;
}

void CConvDlg::OnOK()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	// Ȃ悤ɂ
}

void CConvDlg::UpdateGoButton(void)
{
	m_GoEnable = CheckData();

	m_Button_Go.EnableWindow(m_GoEnable);
}

void CConvDlg::OnEnUpdateEditDownlink()
{
	UpdateGoButton();
}
void CConvDlg::OnEnUpdateEditQuality()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditIss()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditIss2()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditSYy()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditSMm()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditSDd()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditSH()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditSM()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditSS()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditEYy()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditEMm()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditEDd()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditEH()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditEM()
{
	UpdateGoButton();
}

void CConvDlg::OnEnUpdateEditES()
{
	UpdateGoButton();
}

void CConvDlg::OnCbnSelchangeComboSensor()
{
	UpdateGoButton();
}

void CConvDlg::OnCbnEditchangeComboSensor()
{
	UpdateGoButton();
}

void CConvDlg::OnCbnSelchangeComboCategory()
{
	UpdateGoButton();
}

void CConvDlg::OnCbnEditchangeComboCategory()
{
	UpdateGoButton();
}

void CConvDlg::OnCbnSelchangeComboMeasurementKind()
{
	UpdateGoButton();
}

void CConvDlg::OnCbnEditchangeComboMeasurementKind()
{
	UpdateGoButton();
}

//*****************************************************************************************************
//  1. ֐
//		CConvDlg::PreTranslateMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEbZ[W
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		MSG*	pMsg			[I] MSG\̂ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	eNX̕Ԓl̂܂ܕԂ
//*****************************************************************************************************
BOOL CConvDlg::PreTranslateMessage(MSG* pMsg)
{
	// c[`bv\邽߂̏
	switch(pMsg->message){
	case WM_LBUTTONDOWN:            
	case WM_LBUTTONUP:              
	case WM_MOUSEMOVE:
		if (m_tooltip.m_hWnd)
			m_tooltip.RelayEvent(pMsg);
		break;
	}

	return CDialog::PreTranslateMessage(pMsg);
}
